﻿package
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.*
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	
	public class Brancher extends Sprite
	{
		private var rot:Number;
		private var TrunkWidth:Number;
		private var theta:Number=0;
		private var stack:Array = new Array();
		private var i:Number;
		private var centerX:Number;
		private var centerY:Number;
		public function Brancher()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			centerX = e.stageX;
			centerY = e.stageY;
			theta= Math.random()*400;
			TrunkWidth= Math.random()*2;
			i=0;
			rot=Math.cos(Math.PI/Math.random()*360);
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			theta+=0.1;
			var glow:GlowFilter = new GlowFilter();
			if(i< theta){
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0x000000,1);
				stack[i].graphics.lineStyle(1,0xffffff,1);
				stack[i].graphics.drawCircle(0,0,10);
				stack[i].x = centerX+Math.cos(rot)*i/2;
				stack[i].y = centerY-Math.sin(rot)*i/2;
				stack[i].scaleX =TrunkWidth-i/mouseX/10;
				stack[i].scaleY =TrunkWidth-i/mouseY/10;
				
				glow.color = 0x000000;
				glow.alpha = 1;
				glow.blurX = 5;
				glow.blurY = 5;
				glow.quality = BitmapFilterQuality.MEDIUM;
				this.filters = [glow];
				
				addChild(stack[i]);
				i++;
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0x000000,1);
				stack[i].graphics.lineStyle(1,0xffffff,1);
				stack[i].graphics.drawCircle(0,0,10);
				stack[i].x = centerX+Math.abs(rot)*i/2;
				stack[i].y = centerY+Math.cos(rot)*i/2;
				stack[i].scaleX =TrunkWidth-i/mouseX/10;
				stack[i].scaleY =TrunkWidth-i/mouseY/10;
				
				glow.color = 0x000000;
				glow.alpha = 1;
				glow.blurX = 5;
				glow.blurY = 5;
				glow.quality = BitmapFilterQuality.MEDIUM;
				this.filters = [glow];
				
				addChild(stack[i]);
				i++;
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0x000000,1);
				stack[i].graphics.lineStyle(1,0xffffff,1);
				stack[i].graphics.drawCircle(0,0,10);
				stack[i].x = centerY-Math.cos(rot)*i/2;
				stack[i].y = centerX-Math.sin(rot)*i/2;
				stack[i].scaleX =TrunkWidth-i/mouseX/10;
				stack[i].scaleY =TrunkWidth-i/mouseY/10;
				
				glow.color = 0x000000;
				glow.alpha = 1;
				glow.blurX = 5;
				glow.blurY = 5;
				glow.quality = BitmapFilterQuality.MEDIUM;
				this.filters = [glow];
				
				addChild(stack[i]);
				i++;
				stack[i] = new Sprite();
				stack[i].graphics.beginFill(0x000000,1);
				stack[i].graphics.lineStyle(1,0xffffff,1);
				stack[i].graphics.drawCircle(0,0,10);
				stack[i].x = centerX-Math.cos(rot)*i/2;
				stack[i].y = centerY+Math.sin(rot)*i/2;
				stack[i].scaleX =TrunkWidth-i/mouseX/10;
				stack[i].scaleY =TrunkWidth-i/mouseY/10;
				
				glow.color = 0x000000;
				glow.alpha = 1;
				glow.blurX = 5;
				glow.blurY = 5;
				glow.quality = BitmapFilterQuality.MEDIUM;
				this.filters = [glow];

				addChild(stack[i]);
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,enterHandler);
			}
		}
	}
}